/*****************************************************/
/* Exemplo de uso de macros e da funo fetestexcept */
/* para tratamento de excees de ponto flutuante    */
/*****************************************************/

#include <stdio.h>
#include <float.h>
#include <fenv.h>

int main()
{
   int     flags;
   double  x;

#pragma STDC FENV_ACCESS ON

   x = 2.0/3.0; /* Causa uma exceo de inexatido */

   x = DBL_MIN / 5.0; /* Deve causar underflow */

      /* Ao contrrio do que muitos pensam, a  */
      /* instruo seguinte no causa o aborto */
      /* do programa. Ela simplesmente liga o  */
      /* sinalizador de exceo de operao    */
      /* invlida e o resultado armazenado em  */
      /* x  indefinido.                       */
   x = 0.0/0.0;
   printf("%f", x);

      /* Armazena todas em flags as excees de */
      /* ponto flutuante que se desejam testar  */
   flags = fetestexcept( FE_UNDERFLOW |
                         FE_INEXACT |
                         FE_INVALID );

      /* Agora testa que tipo de execeo de ponto */
      /* flutuante ocorreu nas operaes acima     */

   if (flags & FE_UNDERFLOW)
      printf("\nOcorreu overflow numa das operacoes\n");

   if (flags & FE_INEXACT)
      printf( "\nFoi executada uma operacao que "
              "resultou num valor inexato\n" );

   if (flags & FE_INVALID)
      printf( "\nHouve uma tentativa de execucao de "
              "operacao invalida\n" );

   return 0;
}

/*

Resultado do programa no Windows XP:

-1.#IND00
Houve uma tentativa de execucao de operacao invalida

*/
