#include <stdio.h>
#include <stdarg.h>

/****
 *
 * Funo MultiInt2(): calcula o produto de um nmero
 *                    indefinido de termos do tipo int
 *
 * Argumentos: nTermos (entrada) - nmero de termos que
 *                                 sero multiplicados
 *             termos (entrada) - os termos que sero
 *                                multiplicados
 *
 * Retorno: o produto dos termos
 *
 ****/
int MultiInt2(int nTermos, va_list termos)
{
   int i, produto = 1;

   for (i = 0; i < nTermos; i++)
      produto *= va_arg(termos, int);

   return produto;
}

/****
 *
 * Funo ApresentaProduto(): calcula e apresenta o
 *                            produto de um nmero
 *                            indefinido de termos
 *                            do tipo int
 *
 * Argumentos: nTermos (entrada) - nmero de termos que
 *                                 sero multiplicados
 *             ... (entrada) - os termos que sero
 *                             multiplicados
 *
 * Retorno: Nada
 *
 ****/
void ApresentaProduto(int nTermos, ...)
{
   va_list listaArgs;
   int     i, produto;

   va_start(listaArgs, nTermos);

   printf("\nNumeros: ");

      /* Imprime os termos */
   for (i = 0; i < nTermos; i++)
      printf("%d ", va_arg(listaArgs, int));

      /* Para processar a lista de argumentos    */
      /* novamente,  necessrio reinici-la.    */
      /* Mas, antes  necessrio chamar a macro  */
      /* va_end para encerrar o uso iniciado com */
      /* a ltima chamada de va_start:           */
   va_end(listaArgs);

      /* Evidentemente, esta prpria funo poderia   */
      /* calcular e apresentar o produto dos nmeros. */
      /* Mas, a ttulo de ilustrao, esta tarefa     */
      /* ser delegada para a funo MultiInt2().     */

      /* Reinicia a lista de argumentos */
   va_start(listaArgs, nTermos);

   produto = MultiInt2(nTermos, listaArgs);

   printf("\nProduto dos numeros: %d\n", produto);

   va_end(listaArgs);
}

int main(void)
{
   int i1 = 1, i2 = 2, i3 = 3, i4 = 4;

   ApresentaProduto(4, i1, i2, i3, i4);

   return 0;
}

/*

Resultado do programa:

Numeros: 1 2 3 4
Produto dos numeros: 24

*/
