/*******************************************/
/* Exemplo de uso da varivel global errno */
/* e da macro EDOM definida em <errno.h>   */
/*******************************************/

#include <stdio.h>
#include <math.h>
#include <errno.h>

int main()
{
   double x = 1.5, y = 0.5, z;

      /* Aqui, no  necessrio zerar  */
      /* a varivel errno, mas  bom   */
      /* adquirir o hbito de fazer    */
      /* isto para no esquecer quando */
      /* for realmente necessrio      */
   errno = 0;

      /* A funo acos() atribui o valor   */
      /* EDOM  varivel global errno se   */
      /* o valor do argumento estiver fora */
      /* do intervalo [-1, 1]              */
   z = acos(x);

   if (errno == EDOM)
      printf( "O valor %f esta' fora do intervalo"
              " valido de acos()\n", x );
   else
      printf("Valor de acos(%f): %f\n", x, z);

      /* Aqui,  estritamente necessrio   */
      /* zerar a varivel errno. Caso      */
      /* contrrio, ela poder continuar   */
      /* com o valor que lhe foi atribudo */
      /* na chamada anterior de acos().    */
   errno = 0;

   z = acos(y);

   if (errno == EDOM)
      printf( "O valor %f esta' fora do intervalo"
              " valido de acos()\n", y );
   else
      printf("Valor de acos(%f): %f\n", y, z);

   return 0;
}
